    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * DialLayer.java
    029     * --------------
    030     * (C) Copyright 2006-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 03-Nov-2006 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.plot.dial;
    042
    043    import java.awt.Graphics2D;
    044    import java.awt.geom.Rectangle2D;
    045    import java.io.Serializable;
    046    import java.util.EventListener;
    047
    048    /**
    049     * A dial layer draws itself within a reference frame.  The view frame is a
    050     * subset of the reference frame, and defines the area that is actually
    051     * visible.
    052     * <br><br>
    053     * Classes that implement this interface should be {@link Serializable},
    054     * otherwise chart serialization may fail.
    055     *
    056     * @since 1.0.7
    057     */
    058    public interface DialLayer {
    059
    060        /**
    061         * Returns a flag that indicates whether or not the layer is visible.
    062         *
    063         * @return A boolean.
    064         */
    065        public boolean isVisible();
    066
    067        /**
    068         * Registers a listener with this layer, so that it receives notification
    069         * of changes to this layer.
    070         *
    071         * @param listener  the listener.
    072         */
    073        public void addChangeListener(DialLayerChangeListener listener);
    074
    075        /**
    076         * Deregisters a listener, so that it no longer receives notification of
    077         * changes to this layer.
    078         *
    079         * @param listener  the listener.
    080         */
    081        public void removeChangeListener(DialLayerChangeListener listener);
    082
    083        /**
    084         * Returns <code>true</code> if the specified listener is currently
    085         * registered with the this layer.
    086         *
    087         * @param listener  the listener.
    088         *
    089         * @return A boolean.
    090         */
    091        public boolean hasListener(EventListener listener);
    092
    093        /**
    094         * Returns <code>true</code> if the drawing should be clipped to the
    095         * dial window (which is defined by the {@link DialFrame}), and
    096         * <code>false</code> otherwise.
    097         *
    098         * @return A boolean.
    099         */
    100        public boolean isClippedToWindow();
    101
    102        /**
    103         * Draws the content of this layer.
    104         *
    105         * @param g2  the graphics target (<code>null</code> not permitted).
    106         * @param plot  the plot (typically this should not be <code>null</code>,
    107         *     but for a layer that doesn't need to reference the plot, it may
    108         *     be permitted).
    109         * @param frame  the reference frame for the dial's geometry
    110         *     (<code>null</code> not permitted).  This is typically larger than
    111         *     the visible area of the dial (see the next parameter).
    112         * @param view  the visible area for the dial (<code>null</code> not
    113         *     permitted).
    114         */
    115        public void draw(Graphics2D g2, DialPlot plot, Rectangle2D frame,
    116                Rectangle2D view);
    117
    118    }